---
title: 'The Firefox codebase: CSS Guidelines'
slug: Mozilla/Developer_guide/CSS_Guidelines
tags:
  - CSS
  - Firefox
  - Guidelines
---
<p>{{Draft}}</p>

<p class="summary">This document contains guidelines defining how CSS inside the Firefox codebase should be written, it is notably relevant for Firefox front-end engineers.</p>

<h2 id="Basics">Basics</h2>

<p>Here are some basic tips that can optimize reviews if you are changing CSS:</p>

<ul>
 <li>Avoid <code>!important</code> but if you have to use it, make sure it's obvious why you're using it (ideally with a comment). The {{anch("Overriding CSS")}} section contains more information about this.</li>
 <li>Avoid magic numbers; prefer automatic sizing or alignment methods. Some examples to avoid:
  <ul>
   <li>absolutely positioned elements</li>
   <li>hardcoded values such as: <code>vertical-align: -2px;</code> . The reason you should avoid such "hardcoded" values is that, they don't necessarily work for all font-size configurations.</li>
  </ul>
 </li>
 <li>Avoid setting styles in JavaScript. It's generally better to set a class and then specify the styles in CSS.</li>
 <li><code>classList</code> is generally better than <code>className</code>. There's less chance of overwriting an existing class.</li>
 <li>Only use generic selectors such as <code>:last-child</code>, when it is what you mean semantically. If not, using a semantic class name is more descriptive and usually better.</li>
</ul>

<h3 id="Boilerplate">Boilerplate</h3>

<p>Make sure each file starts with the standard copyright header (see <a href="https://www.mozilla.org/MPL/headers/">License Boilerplate</a>).</p>

<h3 id="Before_adding_more_CSS">Before adding more CSS</h3>

<p>It is good practice to check if the CSS that is being written is needed, it can be the case that a common component has been already written could be reused with or without changes. Most of the time, the common component already follows the a11y/theme standards defined in this guide. So, when possible, always prefer editing common components to writing your own.</p>

<p>Also, it is good practice to introduce a common class when the new element you are styling reuses some styles from another element, this allows the maintenance cost and the amount of code duplication to be reduced.</p>

<h2 id="Formatting">Formatting</h2>

<h3 id="Spacing_Indentation">Spacing &amp; Indentation</h3>

<ul>
 <li>2 spaces indentation is preferred</li>
 <li>Add a space after each comma, <strong>except</strong> within color functions:</li>
</ul>

<pre class="brush: css example-good">linear-gradient(to bottom, black 1px, rgba(255,255,255,0.2) 1px)
</pre>

<ul>
 <li>Always add a space before <code>!important</code>.</li>
</ul>

<h3 id="Omit_units_on_0_values">Omit units on 0 values</h3>

<p>Do this:</p>

<pre class="brush: css example-good">  margin: 0;
</pre>

<p>Not this:</p>

<pre class="brush: css example-bad">  margin: 0px;
</pre>

<ul>
</ul>

<h3 id="Use_expanded_syntax">Use expanded syntax</h3>

<p>It is often harder to understand what the shorthand is doing and the shorthand can also hide some unwanted default values. It is good to privilege expanded syntax to make your intentions explicit.</p>

<p>Do this:</p>

<pre class="brush: css example-good">  border-color: red;
</pre>

<p>Not this:</p>

<pre class="brush: css example-bad">  border: red;
</pre>

<h3 id="Put_multiple_selectors_on_different_lines">Put multiple selectors on different lines</h3>

<p>Do this:</p>

<pre class="brush: css example-good">h1,
h2,
h3 {
  font-family: sans-serif;
  text-align: center;
}</pre>

<p>Not this:</p>

<pre class="brush: css example-bad">h1, h2, h3 {
  font-family: sans-serif;
  text-align: center;
}</pre>

<h3 id="Naming_standards_for_class_names">Naming standards for class names</h3>

<ul>
 <li><code>lower-case-with-dashes</code> is the most common.</li>
 <li>But <code>camelCase</code> is also used sometimes. Try to follow the style of existing or related code.</li>
</ul>

<h3 id="Other_tips">Other tips</h3>

<ul>
 <li>Assume <code>="true"</code> in attribute selectors.

  <ul>
   <li>Example: Use <code>option[checked]</code>, not <code>option[checked="true"]</code>.</li>
  </ul>
 </li>
 <li>Avoid ID selectors unless it is really the wanted goal, since IDs have higher specificity and therefore are harder to override.</li>
 <li>Using descendant selectors is good practice for performance when possible:
  <ul>
   <li>For example: <code>.autocomplete-item[selected] &gt; .autocomplete-item-title</code> would be more efficient than <code>.autocomplete-item[selected]  .autocomplete-item-title</code></li>
  </ul>
 </li>
</ul>

<h2 id="Overriding_CSS">Overriding CSS</h2>

<p>Before overriding any CSS rules, check whether overriding is really needed. Sometimes, when copy-pasting older code, it happens that the code in question contains unnecessary overrides. This could be because the CSS that it was overriding got removed in the meantime. In this case, dropping the override should work.</p>

<p>It is also good practice to look at whether the rule you are overriding is still needed: maybe the UX spec for the component has changed and that rule can actually be updated or removed. When this is the case, don't be afraid to remove or update that rule.</p>

<p>Once the two things above have been checked, check if the other rule you are overriding contains <code>!important</code>, if that is case, try putting it in question, because it might have become obsolete.</p>

<p>Afterwards, check the specificity of the other selector; if it is causing your rule to be overriden, you can try reducing its specificity, either by simplifying the selector or by changing where the rule is placed in the stylesheet. If this isn't possible, you can also try introducing a <code>:not()</code> to prevent the other rule from applying, this is especially relevant for different element states (<code>:hover</code>, <code>:active</code>, <code>[checked]</code> or <code>[disabled]</code>). However, never try to increase the selector of the rule you are adding as it can easily become hard to understand.</p>

<p>Finally, once you have checked all the things above, you can permit yourself to use <code>!important</code> along with a comment why it is needed.</p>

<h2 id="Using_CSS_variables">Using CSS variables</h2>

<h3 id="Adding_new_variables">Adding new variables</h3>

<p>Before adding new CSS variables, please consider the following questions:</p>

<ol>
 <li><strong>Is the variable value changed at runtime?</strong><br>
  <em>(Either from JavaScript or overriden by another CSS file)</em><br>
  <br>
  <strong>If the answer is no</strong>, consider using a preprocessor variable or inlining the value.<br>
   </li>
 <li><strong>Is the variable value used multiple times?</strong><br>
  <br>
  <strong>If the answer is no and the value isn't changed at runtime</strong>, then you likely don't need a CSS variable.<br>
   </li>
 <li><strong>Is there an alternative to using the variable like inheriting or using the <code>currentcolor</code> keyword?</strong><br>
  Using inheriting or using <code>currentcolor</code> will prevent repetition of the value and it is usually good practice to do so.</li>
</ol>

<p>In general, it's good to first think of how some CSS could be written cleanly without the CSS variable(s) and then think of how the CSS variable could improve that CSS.</p>

<h3 id="Using_variables">Using variables</h3>

<h4 id="Use_the_variable_according_to_its_naming">Use the variable according to its naming</h4>

<p>Do this:</p>

<pre class="brush: css example-good">xul|tab:hover {
  background-color: var(--in-content-box-background-hover);
}
</pre>

<p>Not this:</p>

<pre class="brush: css example-bad">#certificateErrorDebugInformation {
  background-color: var(--in-content-box-background-hover);
}
</pre>

<h2 id="Localization">Localization</h2>

<h3 id="Text_Direction">Text Direction</h3>

<ul>
 <li>For margins, padding and borders, use {{cssxref("inline-start")}}/{{cssxref("inline-end")}} rather than {{cssxref("left")}}/{{cssxref("right")}}.<br>
  <em>Example:</em> Use <code>margin-inline-start: 3px;</code> instead of <code>margin-left: 3px</code>.</li>
 <li>For RTL-aware positioning (left/right), use {{cssxref("inset-inline-start")}}/{{cssxref("inset-inline-end")}}.</li>
 <li>For RTL-aware float layouts, {{cssxref("float")}}<code>: inline-start|inline-end</code> can be used instead of <code>float: left|right</code>.</li>
 <li>The RTL-aware equivalents of <code>border-{top/bottom}-{left/right}-radius</code> are <code>border-{start/end}-{start/end}-radius</code></li>
 <li>When there is no special RTL-aware property available, use the pseudo <code>:-moz-locale-dir(ltr|rtl)</code> (for XUL files) or <code>:dir(ltr|rtl)</code> (for HTML files).</li>
 <li>Remember that while a tab content's scrollbar still shows on the right in RTL, an overflow scrollbar will show on the left.</li>
 <li>Write {{cssxref("padding")}}<code>: 0 3px 4px;</code> instead of <code>padding: 0 3px 4px 3px;</code>. This makes it more obvious that the padding is symmetrical (so RTL won't be an issue).</li>
</ul>

<div class="notecard note">
<p><strong>Note</strong>: See <a href="/en-US/docs/Web/CSS/CSS_Logical_Properties">CSS Logical Properties and Values</a> for more information.</p>
</div>

<h3 id="Testing">Testing</h3>

<p>To test for RTL layouts, you can go to <code>about:config</code> and set <code>intl.uidirection</code> to <code>-1</code>.</p>

<h2 id="Writing_cross-platform_CSS">Writing cross-platform CSS</h2>

<p>Firefox supports many different platforms and each of those platforms can contain many different configurations:</p>

<ul>
 <li>Windows 7, 8 and 10
  <ul>
   <li>Default theme</li>
   <li>Aero basic (Windows 7, 8)</li>
   <li>Windows classic (Windows 7)</li>
   <li>High contrast (All versions)</li>
  </ul>
 </li>
 <li>Linux</li>
 <li>macOS</li>
</ul>

<h3 id="File_structure">File structure</h3>

<ul>
 <li>The <code>browser/</code> directory contains styles specific to Firefox</li>
 <li>The <code>toolkit/</code> directory contains styles that are shared across all toolkit applications (Thunderbird and SeaMonkey)</li>
</ul>

<p>Under each of those two directories, there is a <code>themes</code> directory containing 4 sub-directories:</p>

<ul>
 <li><code>shared</code></li>
 <li><code>linux</code></li>
 <li><code>osx</code></li>
 <li><code>windows</code></li>
</ul>

<p>The <code>shared</code> directories contain styles shared across all 3 platforms, while the other 3 directories contain styles respective to their platform.</p>

<p>For new CSS, when possible try to privilege using the <code>shared</code> directory, instead of writing the same CSS for the 3 platform specific directories, especially for large blocks of CSS.</p>

<h4 id="Content_CSS_vs._Theme_CSS">Content CSS vs. Theme CSS</h4>

<p>The following directories also contain CSS:</p>

<ul>
 <li><code>browser/base/content/</code></li>
 <li><code>toolkit/content/</code></li>
</ul>

<p>These directories contain content CSS, that applies on all platforms, which is styling deemed to be essential for the browser to behave correctly. To determine whether some CSS is theme-side or content-side, it is useful to know that certain CSS properties are going to lean one way or the other: color - 99% of the time it will be theme CSS, overflow - 99% content.</p>

<table style="border: 1px solid #999999; font-size: 90%;">
 <tbody>
  <tr>
   <th>99% theme</th>
   <th>70% theme</th>
   <th>70% content</th>
   <th>99% content</th>
  </tr>
  <tr>
   <td>font-*, color, *-color, border-*, -moz-appearance [1]</td>
   <td>line-height, padding, margin</td>
   <td>cursor, width, max-width, top, bottom [2], etc</td>
   <td>overflow, direction, display, *-align, align-*, *-box-*, flex-*, order</td>
  </tr>
 </tbody>
</table>

<p>If some CSS is layout or functionality related, then it is likely content CSS. If it is esthetics related, then it is likely theme CSS.</p>

<p>When importing your stylesheets, it's best to import the content CSS before the theme CSS, that way the theme values get to override the content values (which is probably what you want), and you're going to want them both after the global values, so your imports will look like this:</p>

<pre>&lt;?xml-stylesheet href="chrome://global/skin/global.css" type="text/css"?&gt;
&lt;?xml-stylesheet href="chrome://browser/content/path/module.css" type="text/css"?&gt;
&lt;?xml-stylesheet href="chrome://browser/skin/path/module.css" type="text/css"?&gt;
</pre>

<p>[1] -moz-appearance is tricky. Generally, when specifying -moz-appearance: foo; you're giving hints as to how something should act, however -moz-appearance: none; is probably saying 'ignore browser preconceptions - I want a blank sheet', so that's more visual. However -moz-appearance values aren't implemented and don't behave consistently across platforms, so idealism aside -moz-appearance should always be in theme CSS.</p>

<p>[2] However there is probably a better way than using absolute positioning.</p>

<h3 id="Colors">Colors</h3>

<p>For common areas of the Firefox interface (panels, toolbar buttons, etc.), mozilla-central often comes with some useful CSS variables that are adjusted with the correct values for different platform configurations, so using those CSS variables can definitively save some testing time, as you can assume they already work correctly.</p>

<p>Using the <code>currentcolor</code> keyword or inheriting is also good practice, because sometimes the needed value is already in the color or on the parent element. This is especially useful in conjunction with icons using <code>-moz-context-properties: fill;</code> where the icon can adjust to the right platform color automatically from the text color. It is also possible to use <code>currentcolor</code> with other properties like {{cssxref("opacity")}} or {{cssxref("fill-opacity")}} to have different opacities of the platform color.</p>

<ul>
</ul>

<h3 id="High_contrast_mode">High contrast mode</h3>

<h4 id="Content_area">Content area</h4>

<p>On Windows high contrast mode, in the content area, Gecko does some automatic color adjustments regarding page colors. Part of those adjustments include making all <code>box-shadow</code> invisible, so this is something to be aware of if you create a focus ring or a border using the <code>box-shadow</code> property: consider using a <code>border</code> or an <code>outline</code> if you want the border/focus ring to stay visible in high-contrast mode. An example of such bug is <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1516767">bug 1516767</a>.</p>

<p>Another adjustment to be aware of is that Gecko removes all the <code>background-image</code> when high contrast mode is enabled. Consider using an actual <code>&lt;img&gt;</code> tag (for HTML documents) or <code>list-style-image</code> (for XUL documents) if rendering the image is important.</p>

<p>If you are not using Windows, one way to test against those adjustments on other platforms is:</p>

<ul>
 <li>Going to about:preferences</li>
 <li>Clicking on the "Colors..." button in the "Fonts &amp; Colors" sub-section of the "Language and Appearance" section</li>
 <li>Under "Override the colors specified by the page with your selections above", select the "Always" option</li>
</ul>

<h4 id="Chrome_area">Chrome area</h4>

<p>The automatic adjustments previously mentioned only apply to pages rendered in the content area. The chrome area of Firefox uses colors as authored, which is why using pre-defined variables, <code>currentcolor</code> or inheritance is useful to integrate with the system theme with little hassle.</p>

<p>If not, as a last resort, using <a href="/en-US/docs/Web/CSS/color_value#System_Colors">system colors</a> also works for non-default Windows themes or Linux. In general, the following colors are used:</p>

<ul>
 <li><code>-moz-Field</code>: textbox or field background colors, also used as the background color of listboxes or trees.</li>
 <li><code>-moz-FieldText</code>: textbox or field text colors, also used as the text color of listboxes or trees.</li>
 <li><code>-moz-Dialog</code>: window or dialog background color.</li>
 <li><code>-moz-DialogText</code>: window or dialog text color.</li>
 <li><code>GrayText</code>: used on disabled items as text color. Do not use it on text that is not disabled to desemphsize text, because it does not guarantee a sufficient contrast ratio for non-disabled text.</li>
 <li><code>ThreeDShadow</code>: Used as border on elements.</li>
 <li><code>ThreeDLightShadow</code>: Used as light border on elements.</li>
</ul>

<p>Using the background/text pairs is especially important to ensure the contrast is respected in all situations. Never mix custom text colors with a system background color and vice-versa.</p>

<p>Note that using system colors is only useful for the chrome area, since content area colors are overriden by Gecko anyway.</p>

<h3 id="Writing_media_queries">Writing media queries</h3>

<h4 id="Boolean_media_queries">Boolean media queries</h4>

<p>Do this:</p>

<pre class="brush: css example-good">@media (-moz-mac-yosemite-theme: 0) {
</pre>

<p>Not this:</p>

<pre class="brush: css example-bad">@media not all and (-moz-mac-yosemite-theme) {
</pre>

<h4 id="Privilege_CSS_for_most_common_configuration">Privilege CSS for most common configuration</h4>

<p>It is better to put the most common configuration (latest version of an OS, or default theme for example) outside of the media query. In the following example, <code>-moz-mac-yosemite-theme</code> targets macOS 10.10 and higher, so it should be privileged over the styling for macOS 10.9.</p>

<p>Do this:</p>

<pre class="brush: css example-good">@media (-moz-mac-yosemite-theme: 0) {
  #placesList {
    box-shadow: inset -2px 0 0 hsla(0,0%,100%,.2);
  }
}
</pre>

<p>Not this:</p>

<pre class="brush: css example-bad">#placesList {
  box-shadow: inset -2px 0 0 hsla(0,0%,100%,.2);
}

@media (-moz-mac-yosemite-theme) {
  #placesList {
    box-shadow: none;
  }
}</pre>

<ul>
</ul>

<h2 id="Theme_support">Theme support</h2>

<p>Firefox comes built-in with 3 themes: default, light and dark. The built-in light/dark themes are a bit special as they load the <code>compacttheme.css</code> stylesheet. In addition to this, Firefox supports a variety of <a href="/en-US/docs/Mozilla/Add-ons/Themes">WebExtension themes</a> that can be installed from AMO. For testing purposes, <a href="https://addons.mozilla.org/en-US/firefox/addon/arc-dark-theme-we/">here is an example of a WebExtension theme.</a></p>

<h3 id="Writing_theme-friendly_CSS">Writing theme-friendly CSS</h3>

<ul>
 <li>Some CSS variables that are pre-adjusted for different platforms are also pre-adjusted for themes, so it's again a good idea to use them for theme support.</li>
 <li>The text color of elements often contains valuable information from the theme colors, so <code>currentcolor</code>/inheritance is again a good idea for theme support.</li>
 <li>Never write CSS specially for the built-in light/dark theme in <code>compacttheme.css</code> unless that CSS isn't supposed to affect WebExtension themes.</li>
 <li>These selectors can be used to target dark areas:
  <ul>
   <li><code>:-moz-lwtheme-brighttext</code>: dark window frame.</li>
   <li><code>:root[lwt-toolbar-field-brighttext]</code>: dark address bar and searchbar.</li>
   <li><code>:root[lwt-popup-brighttext]</code>: dark arrow panels and autocomplete panels.</li>
   <li><code>:root[lwt-sidebar-brighttext]</code>: dark sidebars.</li>
  </ul>
 </li>
 <li>If you'd like a different shade of a themed area and no CSS variable is adequate, using colors with alpha transparency is usually a good idea, as it will preserve the original theme author's color hue.</li>
</ul>

<h3 id="Variables">Variables</h3>

<p>For clarity, CSS variables that are only used when a theme is enabled have the <code>--lwt-</code> prefix.</p>

<h2 id="Layout_performance">Layout &amp; performance</h2>

<h3 id="Layout">Layout</h3>

<p>Mixing XUL flexbox and HTML flexbox can lead to undefined behaviour.</p>

<h3 id="CSS_selectors">CSS selectors</h3>

<p>When targetting the root element of a page, using <code>:root</code> is the most performant way of doing so.</p>

<h3 id="Reflows_and_style_flushes">Reflows and style flushes</h3>

<p>See <a href="/en-US/docs/Mozilla/Firefox/Performance_best_practices_for_Firefox_fe_engineers">Performance best practices for Firefox front-end engineers</a> for more information about this.</p>

<h2 id="Misc">Misc</h2>

<h3 id="Text_aliasing">Text aliasing</h3>

<p>When convenient, avoid setting the {{cssxref("opacity")}} property on text as it will cause text to be aliased differently.</p>

<h3 id="HDPI_support">HDPI support</h3>

<p>It's recommended to use SVG since it keeps the CSS clean when supporting multiple resolutions. See the <a href="/en-US/docs/Mozilla/Developer_guide/SVG_Guidelines">SVG Guidelines</a> for more information on SVG usage.</p>

<p>However, if only 1x and 2x PNG assets are available, you can use this <code>@media</code> query to target higher density displays (HDPI):</p>

<pre class="brush: css">@media (min-resolution: 1.1dppx)</pre>
